//<html><pre>
/* ----------------------------------------------------------------------------------------------
    basic_logic.java	_H									ver. 1.00 (JDK 1.02)
    																ueyama@infonet.co.jp  2014.06.09
---------------------------------------------------------------------------------------------- */

import java.applet.*;
import java.awt.*;


public class basic_logic extends Applet
{
	int	Tx[]={29,200,388};											// ^l\\ X W
	int	Ty=100;														// ^l\\ Y W
	int	Bx[]={20,192,366};											// Qil\ X W
	int	By=36;														// Qil\ Y W
	int	Im[]={0, 0, 0};												// ̓f[^ (AND, OR, NOT)
	Image		Img;
	
	public void init()
	{
		String bg=getParameter("bgcolor");							// wiF̓ǂݍ
		int bgc=Integer.valueOf(bg,16).intValue();
		setBackground(new Color(bgc));
		MediaTracker mt=new MediaTracker(this);						// 摜t@C̓ǂݍ
		Img=getImage(getCodeBase(), getParameter("figure"));
		mt.addImage(Img, 0);
		try
		{
			mt.waitForID(0);
		}
		catch(InterruptedException e){};
	}
	
	public boolean inside(int x, int a, int b)
	{
		return (x<=Math.max(a,b) && x>=Math.min(a,b)) ? true:false;
	}
	
	public void dsp_g(int x, int y, int m, int n, int c)			// }A̕\
	{
		Graphics	gx=getGraphics();
		int			w=0, h=0, ox=0, oy=0;
		switch(c)
		{
			case	0:	w=486; h= 73; ox=  0; oy= 0;	break;		// {_fq
			case	1:	w=  9; h= 14; ox=488; oy= 0;	break;		// 0, 1
			case	2:	w= 11; h= 12; ox=488; oy=28;	break;		// A, B, X
		}
		gx.clipRect(x,y,w,h);
		gx.clearRect(x,y,w,h);
		gx.drawImage(Img,x-(ox+m*w),y-(oy+n*h),this);
		gx.dispose();
	}
	
	public void paint(Graphics g)
	{
		int i,j,k,x;
		g.clearRect(0,0,size().width,size().height);
		dsp_g(0,0,0,0,0);
		for(i=0; i<2; i++) disp_andor(i);							// AND, OR H}f[^̕\
		disp_not();													// NOT
		g.setColor(new Color(0xdddddd));
		for(i=0; i<3; i++)											// ^l\r`
		{
			for(j=0; j<3; j++)
			{
				if(i==2 && j==2) break;
				for(k=0; k<5; k++)
				{
					if(i==2 && k==3) break;
					g.drawRect(Tx[i]+28*j, Ty+19*k, 28,19);
				}
			}
		}
		for(i=0; i<3; i++)											// ^l\oiA, B, Xj
		{
			for(j=0; j<3; j++) if((i!=2)||(j!=2)) dsp_g(Tx[i]+28*j+9, Ty+4, j, 0, 2);
		}
		disp_tbl();													// ^l\̕\
	}
	
	public boolean mouseDown(Event e, int mx, int my)
	{
		int i,a,b,m,n, x=mx/158, y=(my-120)/19;
		if(my>119 && mx<444)
		{
			if(inside(mx, Tx[x], Tx[x]+84) && !(x==2 && y>1))		// ^l\NbN
			{
				Im[x] = y;
				disp_tbl();
				if(x<2) disp_andor(x);
				else    disp_not();
//				showStatus("Mouse = "+x+", "+y) ;
			}
		}
		if(inside(my, 34, 68))										// _H͕NbN
		{
			for(i=0; i<3; i++)
			{
				if(inside(mx, Bx[i]-20, Bx[i]+29))
				{
					if(i<2)
					{
						n = (my-34)/17;								// n=0: A,  n=1: B NbN
						m = (n==0)? Im[i]/2 : Im[i]%2;
						m=~m&1;
						Im[i] = (n==0)? m*2+Im[i]%2 : Im[i]/2*2+m;
						disp_andor(x);
					}
					else
					{
						Im[i] = ~Im[i]&1;
						disp_not();
					}
				}
			}
			disp_tbl();
		}
		return true;
	}
	
	public void disp_tbl()											// ^l\̕\
	{
		int i,j,a,b,c,x;
		for(i=0; i<2; i++)											// AND OR ^l\
		{
			for(j=0; j<4; j++)
			{
				a = j/2; b = j%2;
				c = (j==Im[i])? 1:0;
				x = (i==0)? a&b:a|b;
				dsp_g(Tx[i]+10, Ty+19*j+22, a, c, 1);
				dsp_g(Tx[i]+38, Ty+19*j+22, b, c, 1);
				dsp_g(Tx[i]+66, Ty+19*j+22, x, c, 1);
			}
		}
		for(a=0; a<2; a++)											// NOT ^l\
		{
			x=~a&1; c = (a==Im[2])? 1:0;
			dsp_g(Tx[2]+10, Ty+19*a+22, a, c, 1);
			dsp_g(Tx[2]+38, Ty+19*a+22, x, c, 1);
		}
	}
	
	public void disp_andor(int n)									// AND, OR H   IN,OUT \
	{
		int a = Im[n]/2, b = Im[n]%2;
		int x = (n==0)? a&b:a|b;
		dsp_g(Bx[n],    By,    a, 0, 1);
		dsp_g(Bx[n]+95, By+9,  x, 0, 1);
		dsp_g(Bx[n],    By+18, b, 0, 1);
	}
	
	public void disp_not()											// NOT H   IN,OUT \
	{
		int n =~Im[2]&1;
		dsp_g(Bx[2], By+9, Im[2], 0, 1);
		dsp_g(Bx[2]+95, By+9, n, 0, 1);
	}
}
//</pre><a HREF="JavaScript:history.go(-1)">߂</A></html>
